<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.xmppstringprep</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;xmppstringprep
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.xmppstringprep-module.html">Module pyxmpp.xmppstringprep</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"><tt class="py-comment"># pylint treats "import stringprep" like depreciated "import string"</tt> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-comment"># pylint: disable-msg=W0402</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring">"""Nodeprep and resourceprep stringprep profiles.</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-docstring">  - `RFC 3920 &lt;http://www.ietf.org/rfc/rfc3920.txt&gt;`__</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">stringprep</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">unicodedata</tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Module pyxmpp.exceptions=pyxmpp.exceptions-module.html"><a title="pyxmpp.exceptions" class="py-name" href="#" onclick="return doclink('link-1', 'exceptions', 'link-1');">exceptions</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Class pyxmpp.exceptions.StringprepError=pyxmpp.exceptions.StringprepError-class.html"><a title="pyxmpp.exceptions.StringprepError" class="py-name" href="#" onclick="return doclink('link-2', 'StringprepError', 'link-2');">StringprepError</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"> </tt>
<a name="LookupFunction"></a><div id="LookupFunction-def"><a name="L32"></a><tt class="py-lineno"> 32</tt> <a class="py-toggle" href="#" id="LookupFunction-toggle" onclick="return toggle('LookupFunction');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.LookupFunction-class.html">LookupFunction</a><tt class="py-op">:</tt> </tt>
</div><div id="LookupFunction-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="LookupFunction-expanded"><a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line">    <tt class="py-docstring">"""Class for looking up RFC 3454 tables using function.</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt class="py-docstring">        - `lookup`: the lookup function."""</tt> </tt>
<a name="LookupFunction.__init__"></a><div id="LookupFunction.__init__-def"><a name="L37"></a><tt class="py-lineno"> 37</tt> <a class="py-toggle" href="#" id="LookupFunction.__init__-toggle" onclick="return toggle('LookupFunction.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.LookupFunction-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">function</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="LookupFunction.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="LookupFunction.__init__-expanded"><a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize `LookupFunction` object.</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring">            - `function`: function taking character code as input and returning</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">              `bool` value or the mapped for `code`."""</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name" targets="Method pyxmpp.xmppstringprep.LookupTable.lookup()=pyxmpp.xmppstringprep.LookupTable-class.html#lookup"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-3', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">=</tt><tt class="py-name">function</tt> </tt>
</div></div><a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"> </tt>
<a name="LookupTable"></a><div id="LookupTable-def"><a name="L45"></a><tt class="py-lineno"> 45</tt> <a class="py-toggle" href="#" id="LookupTable-toggle" onclick="return toggle('LookupTable');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.LookupTable-class.html">LookupTable</a><tt class="py-op">:</tt> </tt>
</div><div id="LookupTable-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="LookupTable-expanded"><a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">    <tt class="py-docstring">"""Class for looking up RFC 3454 tables using a dictionary and/or list of ranges."""</tt> </tt>
<a name="LookupTable.__init__"></a><div id="LookupTable.__init__-def"><a name="L47"></a><tt class="py-lineno"> 47</tt> <a class="py-toggle" href="#" id="LookupTable.__init__-toggle" onclick="return toggle('LookupTable.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.LookupTable-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">singles</tt><tt class="py-op">,</tt><tt class="py-param">ranges</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="LookupTable.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="LookupTable.__init__-expanded"><a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize `LookupTable` object.</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">            - `singles`: dictionary mapping Unicode characters into other Unicode characters.</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">            - `ranges`: list of ``((start,end),value)`` tuples mapping codes in range (start,end)</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">              to the value."""</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">singles</tt><tt class="py-op">=</tt><tt class="py-name">singles</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">ranges</tt><tt class="py-op">=</tt><tt class="py-name">ranges</tt> </tt>
</div><a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line"> </tt>
<a name="LookupTable.lookup"></a><div id="LookupTable.lookup-def"><a name="L57"></a><tt class="py-lineno"> 57</tt> <a class="py-toggle" href="#" id="LookupTable.lookup-toggle" onclick="return toggle('LookupTable.lookup');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.LookupTable-class.html#lookup">lookup</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="LookupTable.lookup-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="LookupTable.lookup-expanded"><a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line">        <tt class="py-docstring">"""Do Unicode character lookup.</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line"><tt class="py-docstring">            - `c`: Unicode character to look up.</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the mapped value."""</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">singles</tt><tt class="py-op">.</tt><tt class="py-name">has_key</tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">singles</tt><tt class="py-op">[</tt><tt class="py-name">c</tt><tt class="py-op">]</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">        <tt class="py-name">c</tt><tt class="py-op">=</tt><tt class="py-name">ord</tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-op">(</tt><tt id="link-4" class="py-name" targets="Method pyxmpp.sasl.core.ClientAuthenticator.start()=pyxmpp.sasl.core.ClientAuthenticator-class.html#start,Method pyxmpp.sasl.core.ServerAuthenticator.start()=pyxmpp.sasl.core.ServerAuthenticator-class.html#start,Method pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.start()=pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator-class.html#start,Method pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.start()=pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#start,Method pyxmpp.sasl.external.ExternalClientAuthenticator.start()=pyxmpp.sasl.external.ExternalClientAuthenticator-class.html#start,Method pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.start()=pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator-class.html#start,Method pyxmpp.sasl.plain.PlainClientAuthenticator.start()=pyxmpp.sasl.plain.PlainClientAuthenticator-class.html#start,Method pyxmpp.sasl.plain.PlainServerAuthenticator.start()=pyxmpp.sasl.plain.PlainServerAuthenticator-class.html#start"><a title="pyxmpp.sasl.core.ClientAuthenticator.start
pyxmpp.sasl.core.ServerAuthenticator.start
pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.start
pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.start
pyxmpp.sasl.external.ExternalClientAuthenticator.start
pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.start
pyxmpp.sasl.plain.PlainClientAuthenticator.start
pyxmpp.sasl.plain.PlainServerAuthenticator.start" class="py-name" href="#" onclick="return doclink('link-4', 'start', 'link-4');">start</a></tt><tt class="py-op">,</tt><tt class="py-name">end</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt id="link-5" class="py-name" targets="Variable pyxmpp.cache.CacheItem.value=pyxmpp.cache.CacheItem-class.html#value"><a title="pyxmpp.cache.CacheItem.value" class="py-name" href="#" onclick="return doclink('link-5', 'value', 'link-5');">value</a></tt> <tt class="py-keyword">in</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">ranges</tt><tt class="py-op">:</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">c</tt><tt class="py-op">&lt;</tt><tt id="link-6" class="py-name"><a title="pyxmpp.sasl.core.ClientAuthenticator.start
pyxmpp.sasl.core.ServerAuthenticator.start
pyxmpp.sasl.digest_md5.DigestMD5ClientAuthenticator.start
pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator.start
pyxmpp.sasl.external.ExternalClientAuthenticator.start
pyxmpp.sasl.gssapi.GSSAPIClientAuthenticator.start
pyxmpp.sasl.plain.PlainClientAuthenticator.start
pyxmpp.sasl.plain.PlainServerAuthenticator.start" class="py-name" href="#" onclick="return doclink('link-6', 'start', 'link-4');">start</a></tt><tt class="py-op">:</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">c</tt><tt class="py-op">&lt;=</tt><tt class="py-name">end</tt><tt class="py-op">:</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt id="link-7" class="py-name"><a title="pyxmpp.cache.CacheItem.value" class="py-name" href="#" onclick="return doclink('link-7', 'value', 'link-5');">value</a></tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
</div></div><a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line"> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line"><tt id="link-8" class="py-name" targets="Variable pyxmpp.xmppstringprep.A_1=pyxmpp.xmppstringprep-module.html#A_1"><a title="pyxmpp.xmppstringprep.A_1" class="py-name" href="#" onclick="return doclink('link-8', 'A_1', 'link-8');">A_1</a></tt><tt class="py-op">=</tt><tt id="link-9" class="py-name" targets="Class pyxmpp.xmppstringprep.LookupFunction=pyxmpp.xmppstringprep.LookupFunction-class.html"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-9', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_a1</tt><tt class="py-op">)</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line"> </tt>
<a name="b1_mapping"></a><div id="b1_mapping-def"><a name="L76"></a><tt class="py-lineno"> 76</tt> <a class="py-toggle" href="#" id="b1_mapping-toggle" onclick="return toggle('b1_mapping');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep-module.html#b1_mapping">b1_mapping</a><tt class="py-op">(</tt><tt class="py-param">uc</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="b1_mapping-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="b1_mapping-expanded"><a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">    <tt class="py-docstring">"""Do RFC 3454 B.1 table mapping.</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line"><tt class="py-docstring">        - `uc`: Unicode character to map.</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line"><tt class="py-docstring">    :returns: u"" if there is `uc` code in the table, `None` otherwise."""</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_b1</tt><tt class="py-op">(</tt><tt class="py-name">uc</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-string">u""</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">    <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
</div><a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line"> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line"><tt id="link-10" class="py-name" targets="Variable pyxmpp.xmppstringprep.B_1=pyxmpp.xmppstringprep-module.html#B_1"><a title="pyxmpp.xmppstringprep.B_1" class="py-name" href="#" onclick="return doclink('link-10', 'B_1', 'link-10');">B_1</a></tt><tt class="py-op">=</tt><tt id="link-11" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-11', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt id="link-12" class="py-name" targets="Function pyxmpp.xmppstringprep.b1_mapping()=pyxmpp.xmppstringprep-module.html#b1_mapping"><a title="pyxmpp.xmppstringprep.b1_mapping" class="py-name" href="#" onclick="return doclink('link-12', 'b1_mapping', 'link-12');">b1_mapping</a></tt><tt class="py-op">)</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line"><tt id="link-13" class="py-name" targets="Variable pyxmpp.xmppstringprep.B_2=pyxmpp.xmppstringprep-module.html#B_2"><a title="pyxmpp.xmppstringprep.B_2" class="py-name" href="#" onclick="return doclink('link-13', 'B_2', 'link-13');">B_2</a></tt><tt class="py-op">=</tt><tt id="link-14" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-14', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">map_table_b2</tt><tt class="py-op">)</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line"><tt id="link-15" class="py-name" targets="Variable pyxmpp.xmppstringprep.B_3=pyxmpp.xmppstringprep-module.html#B_3"><a title="pyxmpp.xmppstringprep.B_3" class="py-name" href="#" onclick="return doclink('link-15', 'B_3', 'link-15');">B_3</a></tt><tt class="py-op">=</tt><tt id="link-16" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-16', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">map_table_b3</tt><tt class="py-op">)</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line"><tt id="link-17" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_1_1=pyxmpp.xmppstringprep-module.html#C_1_1"><a title="pyxmpp.xmppstringprep.C_1_1" class="py-name" href="#" onclick="return doclink('link-17', 'C_1_1', 'link-17');">C_1_1</a></tt><tt class="py-op">=</tt><tt id="link-18" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-18', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c11</tt><tt class="py-op">)</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line"><tt id="link-19" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_1_2=pyxmpp.xmppstringprep-module.html#C_1_2"><a title="pyxmpp.xmppstringprep.C_1_2" class="py-name" href="#" onclick="return doclink('link-19', 'C_1_2', 'link-19');">C_1_2</a></tt><tt class="py-op">=</tt><tt id="link-20" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-20', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c12</tt><tt class="py-op">)</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line"><tt id="link-21" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_2_1=pyxmpp.xmppstringprep-module.html#C_2_1"><a title="pyxmpp.xmppstringprep.C_2_1" class="py-name" href="#" onclick="return doclink('link-21', 'C_2_1', 'link-21');">C_2_1</a></tt><tt class="py-op">=</tt><tt id="link-22" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-22', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c21</tt><tt class="py-op">)</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line"><tt id="link-23" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_2_2=pyxmpp.xmppstringprep-module.html#C_2_2"><a title="pyxmpp.xmppstringprep.C_2_2" class="py-name" href="#" onclick="return doclink('link-23', 'C_2_2', 'link-23');">C_2_2</a></tt><tt class="py-op">=</tt><tt id="link-24" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-24', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c22</tt><tt class="py-op">)</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line"><tt id="link-25" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_3=pyxmpp.xmppstringprep-module.html#C_3"><a title="pyxmpp.xmppstringprep.C_3" class="py-name" href="#" onclick="return doclink('link-25', 'C_3', 'link-25');">C_3</a></tt><tt class="py-op">=</tt><tt id="link-26" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-26', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c3</tt><tt class="py-op">)</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"><tt id="link-27" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_4=pyxmpp.xmppstringprep-module.html#C_4"><a title="pyxmpp.xmppstringprep.C_4" class="py-name" href="#" onclick="return doclink('link-27', 'C_4', 'link-27');">C_4</a></tt><tt class="py-op">=</tt><tt id="link-28" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-28', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c4</tt><tt class="py-op">)</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"><tt id="link-29" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_5=pyxmpp.xmppstringprep-module.html#C_5"><a title="pyxmpp.xmppstringprep.C_5" class="py-name" href="#" onclick="return doclink('link-29', 'C_5', 'link-29');">C_5</a></tt><tt class="py-op">=</tt><tt id="link-30" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-30', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c5</tt><tt class="py-op">)</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line"><tt id="link-31" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_6=pyxmpp.xmppstringprep-module.html#C_6"><a title="pyxmpp.xmppstringprep.C_6" class="py-name" href="#" onclick="return doclink('link-31', 'C_6', 'link-31');">C_6</a></tt><tt class="py-op">=</tt><tt id="link-32" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-32', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c6</tt><tt class="py-op">)</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line"><tt id="link-33" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_7=pyxmpp.xmppstringprep-module.html#C_7"><a title="pyxmpp.xmppstringprep.C_7" class="py-name" href="#" onclick="return doclink('link-33', 'C_7', 'link-33');">C_7</a></tt><tt class="py-op">=</tt><tt id="link-34" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-34', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c7</tt><tt class="py-op">)</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line"><tt id="link-35" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_8=pyxmpp.xmppstringprep-module.html#C_8"><a title="pyxmpp.xmppstringprep.C_8" class="py-name" href="#" onclick="return doclink('link-35', 'C_8', 'link-35');">C_8</a></tt><tt class="py-op">=</tt><tt id="link-36" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-36', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c8</tt><tt class="py-op">)</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line"><tt id="link-37" class="py-name" targets="Variable pyxmpp.xmppstringprep.C_9=pyxmpp.xmppstringprep-module.html#C_9"><a title="pyxmpp.xmppstringprep.C_9" class="py-name" href="#" onclick="return doclink('link-37', 'C_9', 'link-37');">C_9</a></tt><tt class="py-op">=</tt><tt id="link-38" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-38', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_c9</tt><tt class="py-op">)</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line"><tt id="link-39" class="py-name" targets="Variable pyxmpp.xmppstringprep.D_1=pyxmpp.xmppstringprep-module.html#D_1"><a title="pyxmpp.xmppstringprep.D_1" class="py-name" href="#" onclick="return doclink('link-39', 'D_1', 'link-39');">D_1</a></tt><tt class="py-op">=</tt><tt id="link-40" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-40', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_d1</tt><tt class="py-op">)</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line"><tt id="link-41" class="py-name" targets="Variable pyxmpp.xmppstringprep.D_2=pyxmpp.xmppstringprep-module.html#D_2"><a title="pyxmpp.xmppstringprep.D_2" class="py-name" href="#" onclick="return doclink('link-41', 'D_2', 'link-41');">D_2</a></tt><tt class="py-op">=</tt><tt id="link-42" class="py-name"><a title="pyxmpp.xmppstringprep.LookupFunction" class="py-name" href="#" onclick="return doclink('link-42', 'LookupFunction', 'link-9');">LookupFunction</a></tt><tt class="py-op">(</tt><tt class="py-name">stringprep</tt><tt class="py-op">.</tt><tt class="py-name">in_table_d2</tt><tt class="py-op">)</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line"> </tt>
<a name="nfkc"></a><div id="nfkc-def"><a name="L105"></a><tt class="py-lineno">105</tt> <a class="py-toggle" href="#" id="nfkc-toggle" onclick="return toggle('nfkc');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep-module.html#nfkc">nfkc</a><tt class="py-op">(</tt><tt class="py-param">data</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="nfkc-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="nfkc-expanded"><a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">    <tt class="py-docstring">"""Do NFKC normalization of Unicode data.</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line"><tt class="py-docstring">        - `data`: list of Unicode characters or Unicode string.</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line"><tt class="py-docstring">    :return: normalized Unicode string."""</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt id="link-43" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-43', 'type', 'link-43');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-name">list</tt><tt class="py-op">:</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">        <tt class="py-name">data</tt><tt class="py-op">=</tt><tt class="py-string">u""</tt><tt class="py-op">.</tt><tt id="link-44" class="py-name" targets="Method pyxmpp.jabber.muc.MucRoomManager.join()=pyxmpp.jabber.muc.MucRoomManager-class.html#join,Method pyxmpp.jabber.muc.MucRoomState.join()=pyxmpp.jabber.muc.MucRoomState-class.html#join"><a title="pyxmpp.jabber.muc.MucRoomManager.join
pyxmpp.jabber.muc.MucRoomState.join" class="py-name" href="#" onclick="return doclink('link-44', 'join', 'link-44');">join</a></tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">unicodedata</tt><tt class="py-op">.</tt><tt class="py-name">normalize</tt><tt class="py-op">(</tt><tt class="py-string">"NFKC"</tt><tt class="py-op">,</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> </tt>
</div><a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"> </tt>
<a name="Profile"></a><div id="Profile-def"><a name="L116"></a><tt class="py-lineno">116</tt> <a class="py-toggle" href="#" id="Profile-toggle" onclick="return toggle('Profile');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html">Profile</a><tt class="py-op">:</tt> </tt>
</div><div id="Profile-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="Profile-expanded"><a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line">    <tt class="py-docstring">"""Base class for stringprep profiles."""</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">    <tt id="link-45" class="py-name" targets="Variable pyxmpp.xmppstringprep.Profile.cache_items=pyxmpp.xmppstringprep.Profile-class.html#cache_items"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-45', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="Profile.__init__"></a><div id="Profile.__init__-def"><a name="L119"></a><tt class="py-lineno">119</tt> <a class="py-toggle" href="#" id="Profile.__init__-toggle" onclick="return toggle('Profile.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">unassigned</tt><tt class="py-op">,</tt><tt class="py-param">mapping</tt><tt class="py-op">,</tt><tt class="py-param">normalization</tt><tt class="py-op">,</tt><tt class="py-param">prohibited</tt><tt class="py-op">,</tt><tt class="py-param">bidi</tt><tt class="py-op">=</tt><tt class="py-number">1</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.__init__-expanded"><a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize Profile object.</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line"><tt class="py-docstring">            - `unassigned`: the lookup table with unassigned codes</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"><tt class="py-docstring">            - `mapping`: the lookup table with character mappings</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"><tt class="py-docstring">            - `normalization`: the normalization function</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line"><tt class="py-docstring">            - `prohibited`: the lookup table with prohibited characters</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line"><tt class="py-docstring">            - `bidi`: if True then bidirectional checks should be done</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">unassigned</tt><tt class="py-op">=</tt><tt class="py-name">unassigned</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">mapping</tt><tt class="py-op">=</tt><tt class="py-name">mapping</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">normalization</tt><tt class="py-op">=</tt><tt class="py-name">normalization</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">prohibited</tt><tt class="py-op">=</tt><tt class="py-name">prohibited</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">bidi</tt><tt class="py-op">=</tt><tt class="py-name">bidi</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-46" class="py-name" targets="Module pyxmpp.cache=pyxmpp.cache-module.html,Variable pyxmpp.jid.JID.cache=pyxmpp.jid.JID-class.html#cache"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-46', 'cache', 'link-46');">cache</a></tt><tt class="py-op">=</tt><tt class="py-op">{</tt><tt class="py-op">}</tt> </tt>
</div><a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line"> </tt>
<a name="Profile.prepare"></a><div id="Profile.prepare-def"><a name="L136"></a><tt class="py-lineno">136</tt> <a class="py-toggle" href="#" id="Profile.prepare-toggle" onclick="return toggle('Profile.prepare');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#prepare">prepare</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">data</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.prepare-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.prepare-expanded"><a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">        <tt class="py-docstring">"""Complete string preparation procedure for 'stored' strings.</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line"><tt class="py-docstring">        (includes checks for unassigned codes)</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line"><tt class="py-docstring">            - `data`: Unicode string to prepare.</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line"><tt class="py-docstring">        :return: prepared string</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line"><tt class="py-docstring">        :raise StringprepError: if the preparation fails</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">        <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-47" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-47', 'cache', 'link-46');">cache</a></tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">r</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">r</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-48" class="py-name" targets="Method pyxmpp.xmppstringprep.Profile.map()=pyxmpp.xmppstringprep.Profile-class.html#map"><a title="pyxmpp.xmppstringprep.Profile.map" class="py-name" href="#" onclick="return doclink('link-48', 'map', 'link-48');">map</a></tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">normalization</tt><tt class="py-op">:</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">normalization</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-49" class="py-name" targets="Method pyxmpp.xmppstringprep.Profile.prohibit()=pyxmpp.xmppstringprep.Profile-class.html#prohibit"><a title="pyxmpp.xmppstringprep.Profile.prohibit" class="py-name" href="#" onclick="return doclink('link-49', 'prohibit', 'link-49');">prohibit</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-50" class="py-name" targets="Method pyxmpp.xmppstringprep.Profile.check_unassigned()=pyxmpp.xmppstringprep.Profile-class.html#check_unassigned"><a title="pyxmpp.xmppstringprep.Profile.check_unassigned" class="py-name" href="#" onclick="return doclink('link-50', 'check_unassigned', 'link-50');">check_unassigned</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">bidi</tt><tt class="py-op">:</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-51" class="py-name" targets="Method pyxmpp.xmppstringprep.Profile.check_bidi()=pyxmpp.xmppstringprep.Profile-class.html#check_bidi"><a title="pyxmpp.xmppstringprep.Profile.check_bidi" class="py-name" href="#" onclick="return doclink('link-51', 'check_bidi', 'link-51');">check_bidi</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-52" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-52', 'type', 'link-43');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-name">list</tt><tt class="py-op">:</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-string">u""</tt><tt class="py-op">.</tt><tt class="py-name">string</tt><tt class="py-op">.</tt><tt id="link-53" class="py-name"><a title="pyxmpp.jabber.muc.MucRoomManager.join
pyxmpp.jabber.muc.MucRoomState.join" class="py-name" href="#" onclick="return doclink('link-53', 'join', 'link-44');">join</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-54" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-54', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">)</tt><tt class="py-op">&gt;=</tt><tt id="link-55" class="py-name" targets="Variable pyxmpp.xmppstringprep.stringprep_cache_size=pyxmpp.xmppstringprep-module.html#stringprep_cache_size"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-55', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt><tt class="py-op">:</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">            <tt id="link-56" class="py-name" targets="Method pyxmpp.jabber.disco.DiscoIdentity.remove()=pyxmpp.jabber.disco.DiscoIdentity-class.html#remove,Method pyxmpp.jabber.disco.DiscoItem.remove()=pyxmpp.jabber.disco.DiscoItem-class.html#remove"><a title="pyxmpp.jabber.disco.DiscoIdentity.remove
pyxmpp.jabber.disco.DiscoItem.remove" class="py-name" href="#" onclick="return doclink('link-56', 'remove', 'link-56');">remove</a></tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-57" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-57', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt id="link-58" class="py-name"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-58', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt><tt class="py-op">/</tt><tt class="py-number">2</tt><tt class="py-op">]</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">profile</tt><tt class="py-op">,</tt><tt class="py-name">key</tt> <tt class="py-keyword">in</tt> <tt id="link-59" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.remove
pyxmpp.jabber.disco.DiscoItem.remove" class="py-name" href="#" onclick="return doclink('link-59', 'remove', 'link-56');">remove</a></tt><tt class="py-op">:</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">                    <tt class="py-keyword">del</tt> <tt class="py-name">profile</tt><tt class="py-op">.</tt><tt id="link-60" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-60', 'cache', 'link-46');">cache</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt> <tt class="py-name">KeyError</tt><tt class="py-op">:</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">                    <tt class="py-keyword">pass</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-61" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-61', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">]</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-62" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-62', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">[</tt><tt class="py-op">-</tt><tt id="link-63" class="py-name"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-63', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt><tt class="py-op">/</tt><tt class="py-number">2</tt><tt class="py-op">:</tt><tt class="py-op">]</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-64" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-64', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt><tt class="py-name">data</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-65" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-65', 'cache', 'link-46');">cache</a></tt><tt class="py-op">[</tt><tt class="py-name">data</tt><tt class="py-op">]</tt><tt class="py-op">=</tt><tt class="py-name">s</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div><a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line"> </tt>
<a name="Profile.prepare_query"></a><div id="Profile.prepare_query-def"><a name="L171"></a><tt class="py-lineno">171</tt> <a class="py-toggle" href="#" id="Profile.prepare_query-toggle" onclick="return toggle('Profile.prepare_query');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#prepare_query">prepare_query</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.prepare_query-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.prepare_query-expanded"><a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">        <tt class="py-docstring">"""Complete string preparation procedure for 'query' strings.</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line"><tt class="py-docstring">        (without checks for unassigned codes)</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line"><tt class="py-docstring">            - `s`: Unicode string to prepare.</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line"><tt class="py-docstring">        :return: prepared string</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line"><tt class="py-docstring">        :raise StringprepError: if the preparation fails</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line"> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-66" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.map" class="py-name" href="#" onclick="return doclink('link-66', 'map', 'link-48');">map</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">normalization</tt><tt class="py-op">:</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">normalization</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">        <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-67" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.prohibit" class="py-name" href="#" onclick="return doclink('link-67', 'prohibit', 'link-49');">prohibit</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">bidi</tt><tt class="py-op">:</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-68" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.check_bidi" class="py-name" href="#" onclick="return doclink('link-68', 'check_bidi', 'link-51');">check_bidi</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-69" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-69', 'type', 'link-43');">type</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-name">list</tt><tt class="py-op">:</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line">            <tt class="py-name">s</tt><tt class="py-op">=</tt><tt class="py-string">u""</tt><tt class="py-op">.</tt><tt class="py-name">string</tt><tt class="py-op">.</tt><tt id="link-70" class="py-name"><a title="pyxmpp.jabber.muc.MucRoomManager.join
pyxmpp.jabber.muc.MucRoomState.join" class="py-name" href="#" onclick="return doclink('link-70', 'join', 'link-44');">join</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div><a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line"> </tt>
<a name="Profile.map"></a><div id="Profile.map-def"><a name="L193"></a><tt class="py-lineno">193</tt> <a class="py-toggle" href="#" id="Profile.map-toggle" onclick="return toggle('Profile.map');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#map">map</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.map-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.map-expanded"><a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">        <tt class="py-docstring">"""Mapping part of string preparation."""</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line">        <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">c</tt> <tt class="py-keyword">in</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">            <tt class="py-name">rc</tt><tt class="py-op">=</tt><tt class="py-name">None</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">t</tt> <tt class="py-keyword">in</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">mapping</tt><tt class="py-op">:</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line">                <tt class="py-name">rc</tt><tt class="py-op">=</tt><tt class="py-name">t</tt><tt class="py-op">.</tt><tt id="link-71" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-71', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">rc</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line">                    <tt class="py-keyword">break</tt> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">rc</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line">                <tt class="py-name">r</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">)</tt> </tt>
<a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line">                <tt class="py-name">r</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt> </tt>
<a name="L206"></a><tt class="py-lineno">206</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">r</tt> </tt>
</div><a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line"> </tt>
<a name="Profile.prohibit"></a><div id="Profile.prohibit-def"><a name="L208"></a><tt class="py-lineno">208</tt> <a class="py-toggle" href="#" id="Profile.prohibit-toggle" onclick="return toggle('Profile.prohibit');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#prohibit">prohibit</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.prohibit-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.prohibit-expanded"><a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line">        <tt class="py-docstring">"""Checks for prohibited characters."""</tt> </tt>
<a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">c</tt> <tt class="py-keyword">in</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">t</tt> <tt class="py-keyword">in</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">prohibited</tt><tt class="py-op">:</tt> </tt>
<a name="L212"></a><tt class="py-lineno">212</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">t</tt><tt class="py-op">.</tt><tt id="link-72" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-72', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line">                    <tt class="py-keyword">raise</tt> <tt id="link-73" class="py-name"><a title="pyxmpp.exceptions.StringprepError" class="py-name" href="#" onclick="return doclink('link-73', 'StringprepError', 'link-2');">StringprepError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Prohibited character: %r"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">,</tt><tt class="py-op">)</tt> </tt>
<a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div><a name="L215"></a><tt class="py-lineno">215</tt>  <tt class="py-line"> </tt>
<a name="Profile.check_unassigned"></a><div id="Profile.check_unassigned-def"><a name="L216"></a><tt class="py-lineno">216</tt> <a class="py-toggle" href="#" id="Profile.check_unassigned-toggle" onclick="return toggle('Profile.check_unassigned');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#check_unassigned">check_unassigned</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.check_unassigned-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.check_unassigned-expanded"><a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line">        <tt class="py-docstring">"""Checks for unassigned character codes."""</tt> </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">c</tt> <tt class="py-keyword">in</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">t</tt> <tt class="py-keyword">in</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">unassigned</tt><tt class="py-op">:</tt> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">t</tt><tt class="py-op">.</tt><tt id="link-74" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-74', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line">                    <tt class="py-keyword">raise</tt> <tt id="link-75" class="py-name"><a title="pyxmpp.exceptions.StringprepError" class="py-name" href="#" onclick="return doclink('link-75', 'StringprepError', 'link-2');">StringprepError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Unassigned character: %r"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">,</tt><tt class="py-op">)</tt> </tt>
<a name="L222"></a><tt class="py-lineno">222</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div><a name="L223"></a><tt class="py-lineno">223</tt>  <tt class="py-line"> </tt>
<a name="Profile.check_bidi"></a><div id="Profile.check_bidi-def"><a name="L224"></a><tt class="py-lineno">224</tt> <a class="py-toggle" href="#" id="Profile.check_bidi-toggle" onclick="return toggle('Profile.check_bidi');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep.Profile-class.html#check_bidi">check_bidi</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Profile.check_bidi-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Profile.check_bidi-expanded"><a name="L225"></a><tt class="py-lineno">225</tt>  <tt class="py-line">        <tt class="py-docstring">"""Checks if sting is valid for bidirectional printing."""</tt> </tt>
<a name="L226"></a><tt class="py-lineno">226</tt>  <tt class="py-line">        <tt class="py-name">has_l</tt><tt class="py-op">=</tt><tt class="py-number">0</tt> </tt>
<a name="L227"></a><tt class="py-lineno">227</tt>  <tt class="py-line">        <tt class="py-name">has_ral</tt><tt class="py-op">=</tt><tt class="py-number">0</tt> </tt>
<a name="L228"></a><tt class="py-lineno">228</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">c</tt> <tt class="py-keyword">in</tt> <tt class="py-name">s</tt><tt class="py-op">:</tt> </tt>
<a name="L229"></a><tt class="py-lineno">229</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt id="link-76" class="py-name"><a title="pyxmpp.xmppstringprep.D_1" class="py-name" href="#" onclick="return doclink('link-76', 'D_1', 'link-39');">D_1</a></tt><tt class="py-op">.</tt><tt id="link-77" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-77', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L230"></a><tt class="py-lineno">230</tt>  <tt class="py-line">                <tt class="py-name">has_ral</tt><tt class="py-op">=</tt><tt class="py-number">1</tt> </tt>
<a name="L231"></a><tt class="py-lineno">231</tt>  <tt class="py-line">            <tt class="py-keyword">elif</tt> <tt id="link-78" class="py-name"><a title="pyxmpp.xmppstringprep.D_2" class="py-name" href="#" onclick="return doclink('link-78', 'D_2', 'link-41');">D_2</a></tt><tt class="py-op">.</tt><tt id="link-79" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-79', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">c</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L232"></a><tt class="py-lineno">232</tt>  <tt class="py-line">                <tt class="py-name">has_l</tt><tt class="py-op">=</tt><tt class="py-number">1</tt> </tt>
<a name="L233"></a><tt class="py-lineno">233</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">has_l</tt> <tt class="py-keyword">and</tt> <tt class="py-name">has_ral</tt><tt class="py-op">:</tt> </tt>
<a name="L234"></a><tt class="py-lineno">234</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-80" class="py-name"><a title="pyxmpp.exceptions.StringprepError" class="py-name" href="#" onclick="return doclink('link-80', 'StringprepError', 'link-2');">StringprepError</a></tt><tt class="py-op">,</tt><tt class="py-string">"Both RandALCat and LCat characters present"</tt> </tt>
<a name="L235"></a><tt class="py-lineno">235</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">has_l</tt> <tt class="py-keyword">and</tt> <tt class="py-op">(</tt><tt id="link-81" class="py-name"><a title="pyxmpp.xmppstringprep.D_1" class="py-name" href="#" onclick="return doclink('link-81', 'D_1', 'link-39');">D_1</a></tt><tt class="py-op">.</tt><tt id="link-82" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-82', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt> <tt class="py-keyword">or</tt> <tt id="link-83" class="py-name"><a title="pyxmpp.xmppstringprep.D_1" class="py-name" href="#" onclick="return doclink('link-83', 'D_1', 'link-39');">D_1</a></tt><tt class="py-op">.</tt><tt id="link-84" class="py-name"><a title="pyxmpp.xmppstringprep.LookupTable.lookup" class="py-name" href="#" onclick="return doclink('link-84', 'lookup', 'link-3');">lookup</a></tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">[</tt><tt class="py-op">-</tt><tt class="py-number">1</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L236"></a><tt class="py-lineno">236</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-85" class="py-name"><a title="pyxmpp.exceptions.StringprepError" class="py-name" href="#" onclick="return doclink('link-85', 'StringprepError', 'link-2');">StringprepError</a></tt><tt class="py-op">,</tt><tt class="py-string">"The first and the last character must be RandALCat"</tt> </tt>
<a name="L237"></a><tt class="py-lineno">237</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div></div><a name="L238"></a><tt class="py-lineno">238</tt>  <tt class="py-line"> </tt>
<a name="L239"></a><tt class="py-lineno">239</tt>  <tt class="py-line"><tt id="link-86" class="py-name" targets="Variable pyxmpp.xmppstringprep.nodeprep=pyxmpp.xmppstringprep-module.html#nodeprep"><a title="pyxmpp.xmppstringprep.nodeprep" class="py-name" href="#" onclick="return doclink('link-86', 'nodeprep', 'link-86');">nodeprep</a></tt><tt class="py-op">=</tt><tt id="link-87" class="py-name" targets="Class pyxmpp.xmppstringprep.Profile=pyxmpp.xmppstringprep.Profile-class.html"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-87', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">(</tt> </tt>
<a name="L240"></a><tt class="py-lineno">240</tt>  <tt class="py-line">    <tt class="py-name">unassigned</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-88" class="py-name"><a title="pyxmpp.xmppstringprep.A_1" class="py-name" href="#" onclick="return doclink('link-88', 'A_1', 'link-8');">A_1</a></tt><tt class="py-op">,</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L241"></a><tt class="py-lineno">241</tt>  <tt class="py-line">    <tt class="py-name">mapping</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-89" class="py-name"><a title="pyxmpp.xmppstringprep.B_1" class="py-name" href="#" onclick="return doclink('link-89', 'B_1', 'link-10');">B_1</a></tt><tt class="py-op">,</tt><tt id="link-90" class="py-name"><a title="pyxmpp.xmppstringprep.B_2" class="py-name" href="#" onclick="return doclink('link-90', 'B_2', 'link-13');">B_2</a></tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L242"></a><tt class="py-lineno">242</tt>  <tt class="py-line">    <tt class="py-name">normalization</tt><tt class="py-op">=</tt><tt id="link-91" class="py-name" targets="Function pyxmpp.xmppstringprep.nfkc()=pyxmpp.xmppstringprep-module.html#nfkc"><a title="pyxmpp.xmppstringprep.nfkc" class="py-name" href="#" onclick="return doclink('link-91', 'nfkc', 'link-91');">nfkc</a></tt><tt class="py-op">,</tt> </tt>
<a name="L243"></a><tt class="py-lineno">243</tt>  <tt class="py-line">    <tt class="py-name">prohibited</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-92" class="py-name"><a title="pyxmpp.xmppstringprep.C_1_1" class="py-name" href="#" onclick="return doclink('link-92', 'C_1_1', 'link-17');">C_1_1</a></tt><tt class="py-op">,</tt><tt id="link-93" class="py-name"><a title="pyxmpp.xmppstringprep.C_1_2" class="py-name" href="#" onclick="return doclink('link-93', 'C_1_2', 'link-19');">C_1_2</a></tt><tt class="py-op">,</tt><tt id="link-94" class="py-name"><a title="pyxmpp.xmppstringprep.C_2_1" class="py-name" href="#" onclick="return doclink('link-94', 'C_2_1', 'link-21');">C_2_1</a></tt><tt class="py-op">,</tt><tt id="link-95" class="py-name"><a title="pyxmpp.xmppstringprep.C_2_2" class="py-name" href="#" onclick="return doclink('link-95', 'C_2_2', 'link-23');">C_2_2</a></tt><tt class="py-op">,</tt><tt id="link-96" class="py-name"><a title="pyxmpp.xmppstringprep.C_3" class="py-name" href="#" onclick="return doclink('link-96', 'C_3', 'link-25');">C_3</a></tt><tt class="py-op">,</tt><tt id="link-97" class="py-name"><a title="pyxmpp.xmppstringprep.C_4" class="py-name" href="#" onclick="return doclink('link-97', 'C_4', 'link-27');">C_4</a></tt><tt class="py-op">,</tt><tt id="link-98" class="py-name"><a title="pyxmpp.xmppstringprep.C_5" class="py-name" href="#" onclick="return doclink('link-98', 'C_5', 'link-29');">C_5</a></tt><tt class="py-op">,</tt><tt id="link-99" class="py-name"><a title="pyxmpp.xmppstringprep.C_6" class="py-name" href="#" onclick="return doclink('link-99', 'C_6', 'link-31');">C_6</a></tt><tt class="py-op">,</tt><tt id="link-100" class="py-name"><a title="pyxmpp.xmppstringprep.C_7" class="py-name" href="#" onclick="return doclink('link-100', 'C_7', 'link-33');">C_7</a></tt><tt class="py-op">,</tt><tt id="link-101" class="py-name"><a title="pyxmpp.xmppstringprep.C_8" class="py-name" href="#" onclick="return doclink('link-101', 'C_8', 'link-35');">C_8</a></tt><tt class="py-op">,</tt><tt id="link-102" class="py-name"><a title="pyxmpp.xmppstringprep.C_9" class="py-name" href="#" onclick="return doclink('link-102', 'C_9', 'link-37');">C_9</a></tt><tt class="py-op">,</tt> </tt>
<a name="L244"></a><tt class="py-lineno">244</tt>  <tt class="py-line">            <tt id="link-103" class="py-name" targets="Class pyxmpp.xmppstringprep.LookupTable=pyxmpp.xmppstringprep.LookupTable-class.html"><a title="pyxmpp.xmppstringprep.LookupTable" class="py-name" href="#" onclick="return doclink('link-103', 'LookupTable', 'link-103');">LookupTable</a></tt><tt class="py-op">(</tt><tt class="py-op">{</tt><tt class="py-string">u'"'</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u'&amp;'</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u"'"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u"/"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt> </tt>
<a name="L245"></a><tt class="py-lineno">245</tt>  <tt class="py-line">                    <tt class="py-string">u":"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u"&lt;"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u"&gt;"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">,</tt><tt class="py-string">u"@"</tt><tt class="py-op">:</tt><tt class="py-name">True</tt><tt class="py-op">}</tt><tt class="py-op">,</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> <tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L246"></a><tt class="py-lineno">246</tt>  <tt class="py-line">    <tt class="py-name">bidi</tt><tt class="py-op">=</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L247"></a><tt class="py-lineno">247</tt>  <tt class="py-line"> </tt>
<a name="L248"></a><tt class="py-lineno">248</tt>  <tt class="py-line"><tt id="link-104" class="py-name" targets="Variable pyxmpp.xmppstringprep.resourceprep=pyxmpp.xmppstringprep-module.html#resourceprep"><a title="pyxmpp.xmppstringprep.resourceprep" class="py-name" href="#" onclick="return doclink('link-104', 'resourceprep', 'link-104');">resourceprep</a></tt><tt class="py-op">=</tt><tt id="link-105" class="py-name"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-105', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">(</tt> </tt>
<a name="L249"></a><tt class="py-lineno">249</tt>  <tt class="py-line">    <tt class="py-name">unassigned</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-106" class="py-name"><a title="pyxmpp.xmppstringprep.A_1" class="py-name" href="#" onclick="return doclink('link-106', 'A_1', 'link-8');">A_1</a></tt><tt class="py-op">,</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L250"></a><tt class="py-lineno">250</tt>  <tt class="py-line">    <tt class="py-name">mapping</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-107" class="py-name"><a title="pyxmpp.xmppstringprep.B_1" class="py-name" href="#" onclick="return doclink('link-107', 'B_1', 'link-10');">B_1</a></tt><tt class="py-op">,</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L251"></a><tt class="py-lineno">251</tt>  <tt class="py-line">    <tt class="py-name">normalization</tt><tt class="py-op">=</tt><tt id="link-108" class="py-name"><a title="pyxmpp.xmppstringprep.nfkc" class="py-name" href="#" onclick="return doclink('link-108', 'nfkc', 'link-91');">nfkc</a></tt><tt class="py-op">,</tt> </tt>
<a name="L252"></a><tt class="py-lineno">252</tt>  <tt class="py-line">    <tt class="py-name">prohibited</tt><tt class="py-op">=</tt><tt class="py-op">(</tt><tt id="link-109" class="py-name"><a title="pyxmpp.xmppstringprep.C_1_2" class="py-name" href="#" onclick="return doclink('link-109', 'C_1_2', 'link-19');">C_1_2</a></tt><tt class="py-op">,</tt><tt id="link-110" class="py-name"><a title="pyxmpp.xmppstringprep.C_2_1" class="py-name" href="#" onclick="return doclink('link-110', 'C_2_1', 'link-21');">C_2_1</a></tt><tt class="py-op">,</tt><tt id="link-111" class="py-name"><a title="pyxmpp.xmppstringprep.C_2_2" class="py-name" href="#" onclick="return doclink('link-111', 'C_2_2', 'link-23');">C_2_2</a></tt><tt class="py-op">,</tt><tt id="link-112" class="py-name"><a title="pyxmpp.xmppstringprep.C_3" class="py-name" href="#" onclick="return doclink('link-112', 'C_3', 'link-25');">C_3</a></tt><tt class="py-op">,</tt><tt id="link-113" class="py-name"><a title="pyxmpp.xmppstringprep.C_4" class="py-name" href="#" onclick="return doclink('link-113', 'C_4', 'link-27');">C_4</a></tt><tt class="py-op">,</tt><tt id="link-114" class="py-name"><a title="pyxmpp.xmppstringprep.C_5" class="py-name" href="#" onclick="return doclink('link-114', 'C_5', 'link-29');">C_5</a></tt><tt class="py-op">,</tt><tt id="link-115" class="py-name"><a title="pyxmpp.xmppstringprep.C_6" class="py-name" href="#" onclick="return doclink('link-115', 'C_6', 'link-31');">C_6</a></tt><tt class="py-op">,</tt><tt id="link-116" class="py-name"><a title="pyxmpp.xmppstringprep.C_7" class="py-name" href="#" onclick="return doclink('link-116', 'C_7', 'link-33');">C_7</a></tt><tt class="py-op">,</tt><tt id="link-117" class="py-name"><a title="pyxmpp.xmppstringprep.C_8" class="py-name" href="#" onclick="return doclink('link-117', 'C_8', 'link-35');">C_8</a></tt><tt class="py-op">,</tt><tt id="link-118" class="py-name"><a title="pyxmpp.xmppstringprep.C_9" class="py-name" href="#" onclick="return doclink('link-118', 'C_9', 'link-37');">C_9</a></tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L253"></a><tt class="py-lineno">253</tt>  <tt class="py-line">    <tt class="py-name">bidi</tt><tt class="py-op">=</tt><tt class="py-number">1</tt><tt class="py-op">)</tt> </tt>
<a name="L254"></a><tt class="py-lineno">254</tt>  <tt class="py-line"> </tt>
<a name="L255"></a><tt class="py-lineno">255</tt>  <tt class="py-line"><tt id="link-119" class="py-name"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-119', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt><tt class="py-op">=</tt><tt class="py-number">1000</tt> </tt>
<a name="set_stringprep_cache_size"></a><div id="set_stringprep_cache_size-def"><a name="L256"></a><tt class="py-lineno">256</tt> <a class="py-toggle" href="#" id="set_stringprep_cache_size-toggle" onclick="return toggle('set_stringprep_cache_size');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.xmppstringprep-module.html#set_stringprep_cache_size">set_stringprep_cache_size</a><tt class="py-op">(</tt><tt class="py-param">size</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="set_stringprep_cache_size-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="set_stringprep_cache_size-expanded"><a name="L257"></a><tt class="py-lineno">257</tt>  <tt class="py-line">    <tt class="py-docstring">"""Modify stringprep cache size.</tt> </tt>
<a name="L258"></a><tt class="py-lineno">258</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L259"></a><tt class="py-lineno">259</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L260"></a><tt class="py-lineno">260</tt>  <tt class="py-line"><tt class="py-docstring">        - `size`: new cache size"""</tt> </tt>
<a name="L261"></a><tt class="py-lineno">261</tt>  <tt class="py-line">    <tt class="py-keyword">global</tt> <tt id="link-120" class="py-name"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-120', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt> </tt>
<a name="L262"></a><tt class="py-lineno">262</tt>  <tt class="py-line">    <tt id="link-121" class="py-name"><a title="pyxmpp.xmppstringprep.stringprep_cache_size" class="py-name" href="#" onclick="return doclink('link-121', 'stringprep_cache_size', 'link-55');">stringprep_cache_size</a></tt><tt class="py-op">=</tt><tt class="py-name">size</tt> </tt>
<a name="L263"></a><tt class="py-lineno">263</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt id="link-122" class="py-name"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-122', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">.</tt><tt id="link-123" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-123', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">)</tt><tt class="py-op">&gt;</tt><tt class="py-name">size</tt><tt class="py-op">:</tt> </tt>
<a name="L264"></a><tt class="py-lineno">264</tt>  <tt class="py-line">        <tt id="link-124" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.remove
pyxmpp.jabber.disco.DiscoItem.remove" class="py-name" href="#" onclick="return doclink('link-124', 'remove', 'link-56');">remove</a></tt><tt class="py-op">=</tt><tt id="link-125" class="py-name"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-125', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">.</tt><tt id="link-126" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-126', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-name">size</tt><tt class="py-op">]</tt> </tt>
<a name="L265"></a><tt class="py-lineno">265</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">profile</tt><tt class="py-op">,</tt><tt class="py-name">key</tt> <tt class="py-keyword">in</tt> <tt id="link-127" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.remove
pyxmpp.jabber.disco.DiscoItem.remove" class="py-name" href="#" onclick="return doclink('link-127', 'remove', 'link-56');">remove</a></tt><tt class="py-op">:</tt> </tt>
<a name="L266"></a><tt class="py-lineno">266</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L267"></a><tt class="py-lineno">267</tt>  <tt class="py-line">                <tt class="py-keyword">del</tt> <tt class="py-name">profile</tt><tt class="py-op">.</tt><tt id="link-128" class="py-name"><a title="pyxmpp.cache
pyxmpp.jid.JID.cache" class="py-name" href="#" onclick="return doclink('link-128', 'cache', 'link-46');">cache</a></tt><tt class="py-op">[</tt><tt class="py-name">key</tt><tt class="py-op">]</tt> </tt>
<a name="L268"></a><tt class="py-lineno">268</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt> <tt class="py-name">KeyError</tt><tt class="py-op">:</tt> </tt>
<a name="L269"></a><tt class="py-lineno">269</tt>  <tt class="py-line">                <tt class="py-keyword">pass</tt> </tt>
<a name="L270"></a><tt class="py-lineno">270</tt>  <tt class="py-line">        <tt id="link-129" class="py-name"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-129', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">.</tt><tt id="link-130" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-130', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">=</tt><tt id="link-131" class="py-name"><a title="pyxmpp.xmppstringprep.Profile" class="py-name" href="#" onclick="return doclink('link-131', 'Profile', 'link-87');">Profile</a></tt><tt class="py-op">.</tt><tt id="link-132" class="py-name"><a title="pyxmpp.xmppstringprep.Profile.cache_items" class="py-name" href="#" onclick="return doclink('link-132', 'cache_items', 'link-45');">cache_items</a></tt><tt class="py-op">[</tt><tt class="py-op">-</tt><tt class="py-name">size</tt><tt class="py-op">:</tt><tt class="py-op">]</tt> </tt>
</div><a name="L271"></a><tt class="py-lineno">271</tt>  <tt class="py-line"> </tt>
<a name="L272"></a><tt class="py-lineno">272</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L273"></a><tt class="py-lineno">273</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:12 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
